package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/schema/field"
	"entgo.io/ent/schema/index"
)

// AccessControl holds the schema definition for the AccessControl entity.
type AccessControl struct {
	ent.Schema
}

// Fields of the AccessControl.
func (AccessControl) Fields() []ent.Field {
	return []ent.Field{
		fieldID,
		fieldCreated,
		fieldUpdated,
		field.String("ptype").Default(""),
		field.String("v0").Default(""),
		field.String("v1").Default(""),
		field.String("v2").Default(""),
		field.String("v3").Default(""),
		field.String("v4").Default(""),
		field.String("v5").Default(""),
	}
}

// Edges of the AccessControl.
func (AccessControl) Index() []ent.Index {
	return []ent.Index{
		index.Fields("ptype", "v0", "v1", "v2", "v3", "v4", "v5").Unique(),
	}
}
